;       I2C    16 
;      equ ,       SCL  SDA
;     SCL_LINE  SDA_LINE
;               
;     PORT_ADR  TRIS_ADR
;    
;  :
	; BTR
	; BIT_COUNT
	; I2C_FLAGS - 0-  -   , 1-  -   
	;  (0-, 1-)
;    I2C
SCL_LINE	EQU	3
SDA_LINE	EQU	4
PORT_ADR	EQU	PORTC
TRIS_ADR	EQU	TRISC

;----------------------------------------------
;   ""  I2C
;: 	
;: 
;: SCL_L, SCL_H, SDA_L
;: 
;----------------------------------------------
I2C_START_T
	clrwdt				;   .
	pagesel	SCL_H
	call	SCL_H			;   SCL
	pagesel	i2c_start_p
i2c_start_p				;
	btfss	PORT_ADR,SCL_LINE	; ,  SCL  (  SCL   )
	goto	i2c_start_p		;   
	pagesel	SDA_H			;   SDA (    ,   ) 
	call	SDA_H
	pagesel	I2C_PAUSE
	call	I2C_PAUSE		; ,   ,  ,  SDA-1, SCL-1 
	pagesel	SDA_L
	call	SDA_L			;  SDA   () 
	pagesel	I2C_PAUSE
	call	I2C_PAUSE		;   ,   SCL  
	pagesel	SCL_L
	call	SCL_L			;  SCL  
	return
;----------------------------------------------
;   ""  I2C 
;: 	
;: 
;: I2C_PAUSE, SCL_H, SDA_L, SDA_H
;: 
;----------------------------------------------
I2C_STOP_T
	clrwdt				;   .
	pagesel	SDA_L
	call	SDA_L			;  SDA  
	pagesel	SCL_H
	call	SCL_H			;   SCL
	pagesel	i2c_stop_p
i2c_stop_p				;
	btfss	PORT_ADR,SCL_LINE	; ,  SCL  (  SCL   )
	goto	i2c_stop_p		;   
	pagesel	I2C_PAUSE
	call	I2C_PAUSE		;     
	pagesel	SDA_H
	call	SDA_H			;   SDA ()
	pagesel	I2C_PAUSE
	call	I2C_PAUSE		;      
	return
;----------------------------------------------
;    I2C
;: 	BTR(  )
;: I2C_FLAGS, BIT_COUNT, BTR
;: SCL_L, SCL_H, SDA_L, SDA_H 
;: 
;----------------------------------------------
I2C_BYTE_T
	clrwdt				;   .
	bcf	I2C_FLAGS,0		;   
	movlw	.8			; 
	movwf	BIT_COUNT		;   
i2c_byte_t_n
	pagesel	SDA_H
	btfsc	BTR,7			;    SDA
	call	SDA_H
	pagesel	SDA_L
	btfss	BTR,7
	call	SDA_L
	pagesel	I2C_05PAUSE		;       2.4 
	call	I2C_05PAUSE		;    SDA   SCL     SCL
	pagesel	SCL_H
	call	SCL_H			;   SCL( )
i2c_byte_t_w1
	pagesel	i2c_byte_t_w1
	btfss	PORT_ADR,SCL_LINE	; ,  SCL  (  SCL   )
	goto	i2c_byte_t_w1
	pagesel	I2C_PAUSE		;       4  
	call	I2C_PAUSE		;   SCL 
	pagesel	SCL_L
	call	SCL_L			;  SCL  
	pagesel	I2C_05PAUSE		;       2.4  
	call	I2C_05PAUSE		;    SCL
	rlf	BTR,1			;   BTR 
	pagesel	i2c_byte_t_n
	decfsz	BIT_COUNT,1
	goto	i2c_byte_t_n		;    
	pagesel	SDA_H
	call	SDA_H			;   SDA  ,  slave    
	pagesel	I2C_05PAUSE		;       2.4 
	call	I2C_05PAUSE		;    SDA   SCL     SCL
	pagesel	SCL_H
	call	SCL_H			;   SCL
i2c_byte_t_w2
	pagesel	i2c_byte_t_w2
	btfss	PORT_ADR,SCL_LINE	; ,  SCL  (  SCL   )
	goto	i2c_byte_t_w2
	pagesel	I2C_PAUSE		;       4.7  
	call	I2C_PAUSE		;   SCL 
	btfsc	PORT_ADR,SDA_LINE	; ,   SDA ( )
	bsf	I2C_FLAGS,0		;  ,   
	pagesel	SCL_L
	call	SCL_L			;  SCL  
	pagesel	I2C_PAUSE		;       4.7  
	call	I2C_PAUSE		;   SCL 
	return
;----------------------------------------------
;    I2C
;: 	I2C_FLAGS
;: BTR, BIT_COUNT, 
;: SCL_L, SCL_H, SDA_L, SDA_H 
;: BTR		
;----------------------------------------------
I2C_BYTE_R
	clrwdt				;   .
	clrf	BTR			;    
	movlw	.8			; 
	movwf	BIT_COUNT		;   
i2c_byte_r_n
	bcf	STATUS,C		;   
	rlf	BTR,1			;   BTR 
	pagesel	SDA_H
	call	SDA_H			;   SDA  ,  slave   
	pagesel	I2C_05PAUSE		;       2.4 
	call	I2C_05PAUSE		;    SDA   SCL
	pagesel	SCL_H
	call	SCL_H			;   SCL
i2c_byte_r_w1
	pagesel	i2c_byte_r_w1
	btfss	PORT_ADR,SCL_LINE	; ,  SCL  (  SCL   )
	goto	i2c_byte_r_w1
	pagesel	I2C_PAUSE		;       4.7  
	call	I2C_PAUSE		;   SCL 
	btfsc	PORT_ADR,SDA_LINE	; ,   SDA 
	bsf	BTR,0			;  ,  
	pagesel	SCL_L
	call	SCL_L			;  SCL  
	pagesel	I2C_PAUSE		;       4.7  
	call	I2C_PAUSE		;   SCL 
	pagesel	i2c_byte_r_n
	decfsz	BIT_COUNT,1
	goto	i2c_byte_r_n		;    
	pagesel	SDA_L
	btfss	I2C_FLAGS,1		;     
	call	SDA_L			;      I2C_FLAGS (0-, 1-)
	pagesel	SDA_H
	btfsc	I2C_FLAGS,1
	call	SDA_H
	pagesel	I2C_05PAUSE		;       2.4 
	call	I2C_05PAUSE		;    SDA   SCL
	pagesel	SCL_H
	call	SCL_H			;   SCL
	bcf	I2C_FLAGS,1		;   (   )
i2c_byte_r_w2
	pagesel	i2c_byte_r_w2
	btfss	PORT_ADR,SCL_LINE	; ,  SCL  (  SCL   )
	goto	i2c_byte_r_w2
	pagesel	I2C_PAUSE		;       4.7  
	call	I2C_PAUSE		;   SCL 
	pagesel	SCL_L
	call	SCL_L			;  SCL  
	pagesel	I2C_PAUSE		;       4.7  
	call	I2C_PAUSE		;   SCL 
	return
;----------------------------------------------
;     4.7    I2C
;: 	
;: W
;: 
;: 
;----------------------------------------------
I2C_PAUSE
	clrwdt			;   .
	nop
	nop
	nop
	nop
	nop
	nop
	return
;----------------------------------------------
;     2.4    I2C
;: 	
;: W
;: 
;: 
;----------------------------------------------
I2C_05PAUSE
	clrwdt			;   .
	nop
	nop
	nop
	return
;----------------------------------------------
;  0   SCL
;: 	
;: 
;: 
;: 
;----------------------------------------------
SCL_L
	clrwdt			;   .
	bcf  PORT_ADR,SCL_LINE	;       0
	banksel	ADCON1		;    1 
	bcf  TRIS_ADR,SCL_LINE	;       
	banksel	ADCON0		;    0
	return
;----------------------------------------------
;  Z-   SCL
;: 	
;: 
;: 
;: 
;----------------------------------------------
SCL_H
	clrwdt			;   .
	banksel	ADCON1		;    1 
	bsf  TRIS_ADR,SCL_LINE	;       
	banksel	ADCON0		;    0
	return
;----------------------------------------------
;  0   SDA
;: 	
;: 
;: 
;: 
;----------------------------------------------
SDA_L
	clrwdt			;   .
	bcf  PORT_ADR,SDA_LINE	;       0
	banksel	ADCON1		;    1 
	bcf  TRIS_ADR,SDA_LINE	;       
	banksel	ADCON0		;    0
	return
;----------------------------------------------
;  Z-   SDA
;: 	
;: 
;: 
;: 
;----------------------------------------------
SDA_H
	clrwdt			;   .
	banksel	ADCON1		;    1 
	bsf  TRIS_ADR,SDA_LINE	;       
	banksel	ADCON0		;    0
	return