;     RTC DS3231
;  :
	; Year	    
	; Month	   
	; Day	    
	; Week	    
	; Hour	    
	; Minute    
	; Second    

;----------------------------------------------
;  
;: 	
;: W
;: I2C_START_T, I2C_RESTART, I2C_BYTE_T, I2C_BYTE_R, I2C_ACK_R, I2C_NO_ACK_T, I2C_STOP_T, I2C_STOP_R
;: 
;----------------------------------------------
RTC_INIT
	clrwdt			;   .
; ,   
	pagesel	I2C_START_T
	call	I2C_START_T	;   ""
	movlw	B'11010000'	;     
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	movlw	0fH		;    STATUS 
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	pagesel	I2C_START_T
	call	I2C_START_T	;  
	movlw	B'11010001'	;     
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	bsf	I2C_FLAGS,1	;     
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;    STATUS 
	movf	BTR,W		;     I2C
	movwf	Second		;      
	pagesel	I2C_STOP_T
	call	I2C_STOP_T	;   "" 
	pagesel	rtc_init_start
	btfsc	Second,7	;   OSF (   )
	goto	rtc_init_start	;    1,    
	pagesel	rtc_init_end
	goto	rtc_init_end	;   
; 
rtc_init_start
	pagesel	I2C_START_T
	call	I2C_START_T	;   ""
	movlw	B'11010000'	;     
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	pagesel	PAUSE1mS
	call	PAUSE1mS
	movlw	0eH		;    CONTROL 
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movlw	B'00000100'	;   W   CONTROL 
				; BIT0 A1IE = 0 -     1.
				; BIT1 A2IE = 0 -     2.
				; BIT2 INTCN = 1 -     INT/SQW .
				; BIT3, BIT4 RS1, RS2 = 0 -   1     INT/SQW.
				; BIT5 CONV = 0 -    .
				; BIT6 BBSQW = 0 -  INT/SQW      .
				; BIT7 EOSC =  0 -  
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;    CONTROL    
	movlw	B'00001000'	;   W   STATUS 
				; BIT0 A1F = 0 -       1  . 
				; BIT1 A2F = 0 -       2  . 
				; BIT2 BSY = 0   .    . 
				; BIT3 EN32kHz = 1       32   32kHz .
				; BIT7 OSF = 0     .  1 ,   .
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;    STATUS    
	pagesel	I2C_STOP_T
	call	I2C_STOP_T	;   "" 
rtc_init_end
	return
;----------------------------------------------
;    
;: 	
;: W, Year, Month, Day, Hour, Minute, Second, Week
;: I2C_START_T, I2C_RESTART, I2C_BYTE_T, I2C_BYTE_R, I2C_ACK_R, I2C_ACK_T, I2C_NO_ACK_T, I2C_STOP_R, IZMER
;: Year, Month, Day, Hour, Minute, Second, Week
;----------------------------------------------
RTC_READ
	clrwdt			;   .
	pagesel	I2C_START_T
	call	I2C_START_T	;   ""
	movlw	B'11010000'	;     
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	movlw	00H		;     
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	pagesel	I2C_START_T
	call	I2C_START_T	;  
	movlw	B'11010001'	;     
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;       
	movf	BTR,W		;     I2C
	movwf	Second		;      Second
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;       
	movf	BTR,W		;     I2C
	movwf	Minute		;      Minute
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;       
	movf	BTR,W		;     I2C
	movwf	Hour		;      Hour
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;        
	movf	BTR,W		;     I2C
	movwf	Week		;      Week
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;       
	movf	BTR,W		;     I2C
	movwf	Day		;      Day
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;       
	movf	BTR,W		;     I2C
	movwf	Month		;      Month
	bsf	I2C_FLAGS,1	;     
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;       
	movf	BTR,W		;     I2C
	movwf	Year		;      Year
	pagesel	I2C_STOP_T
	call	I2C_STOP_T	;   "" 
	return
;----------------------------------------------
;    
;: 	Hour, Minute, Second, Year, Month, Day, Week
;: W
;: I2C_START_T, I2C_BYTE_T, I2C_ACK_R, I2C_ACK_T, I2C_STOP_T
;: 
;----------------------------------------------
RTC_WRITE
	clrwdt			;   .
	pagesel	I2C_START_T
	call	I2C_START_T	;   ""
	movlw	B'11010000'	;     
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	clrf	BTR		;     
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	Second,W	;   W 
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	Minute,W	;   W 
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	Hour,W		;   W 
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	Week,W		;   W  
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	Day,W		;   W 
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	Month,W		;   W 
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	Year,W		;   W  
	movwf	BTR
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	pagesel	I2C_STOP_T
	call	I2C_STOP_T	;   "" 
	return