;   GPS Neo-6M
;    TM1637
;  PIC16F76
;   I2C: DS3231, AT24C16
;   UART: Neo-6M
; 16 
; : 1 -  - , 2 -  - , 3 -  - .
;==============================================
;   
;==============================================
	list		p=16F76		;   
	#include	<P16F76.INC>	;  ,     
;==============================================
;  
;==============================================
	;    
	;_BODEN_OFF & -      
	;_CP_OFF & -     ,    
	;_PWRTE_ON & -      
	;_WDT_ON & -   
	;_HS_OSC - HS 
	__CONFIG _BODEN_OFF & _CP_OFF & _PWRTE_ON & _WDT_ON & _HS_OSC
;==============================================
;  
;==============================================
#include	<speedometer_pins.INC>	;    
#include	<speedometer_const.INC>	;    
;==============================================
;  
;==============================================
;==============================================
;  
;==============================================
#include	<speedometer_variable.INC>	;    
;==============================================
;	
;==============================================
        org 0		;   
	pagesel	Start
	goto	Start	;   
;==============================================
;	O 
;==============================================
;\/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/
#include	<Interupt_ms.INC>		;     
;/\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\
;==============================================
;	 
;==============================================
Start
	clrf	STATUS		;  0.	
	banksel	INTCON
	clrf	INTCON		;   
;==============================================
;	 
;==============================================
;----------------------------------------------
; 
;----------------------------------------------
;  / 
	banksel	PORTA		;  0.
	clrf	PORTA
	clrf	PORTB
	clrf	PORTC
	banksel	TRISA		;  1.
	movlw	TRISA_CONST
	movwf	TRISA		;   PORTA
	movlw	TRISB_CONST
	movwf	TRISB		;   PORTB
	movlw	TRISC_CONST
	movwf	TRISC		;   PORTC
	movlw	OPTION_CONST	
	movwf	OPTION_REG	;   OPTION_REG
;   
	movlw	ADCON1_CONST	;     
	movwf	ADCON1		;
	banksel	ADCON0		;  0.
	movlw	ADCON0_CONST	;  
	movwf	ADCON0		;
;   PORTC
	clrf	T1CON		;   1
	clrf	T2CON		;   2
	clrf	CCP1CON		;   / 1
	clrf	CCP2CON		;   / 2
;----------------------------------------------
; 
;----------------------------------------------
	clrf	I2C_FLAGS	;    I2C
	clrf	CorrS		;      
	clrf	TIMER_RH	;  
	clrf	TIMER_RL
	clrf	TIMER_B
	clrf	TIMER_D
	clrf	SETTINGS	;   
	clrf	SETTINGS2
	bsf	SETTINGS,0	;   
	clrf	BUTTONS		;    
	clrf	IZM_UP		;    
	clrf	GPS_10H
	clrf	GPS_01H
	clrf	GPS_10M	
	clrf	GPS_01M	
	clrf	GPS_10S
	clrf	GPS_01S
	clrf	GPS_10_D
	clrf	GPS_01_D
	clrf	GPS_10_M
	clrf	GPS_01_M
	clrf	GPS_10Y
	clrf	GPS_01Y
	clrf	GPS_100_S
	clrf	GPS_10_S
	clrf	GPS_01_S
	movlw	b'10001111'	;      
	movwf  	BRIGHTNESS	;  7
	clrf	CALC_I
;----------------------------------------------
; TM1637 -   
;----------------------------------------------
;----------------------------------------------
; RTC DS3231
;----------------------------------------------
	pagesel	RTC_INIT
	call	RTC_INIT	; RTC DS3231
	pagesel	RTC_READ
	call	RTC_READ	;  
;    
	movf	Second,w
	movwf	Second_T	;   
;----------------------------------------------
;   
;----------------------------------------------
	pagesel	FLASH_READ
	call	FLASH_READ
;----------------------------------------------
;  USART
;----------------------------------------------
	banksel	SPBRG		;  1.
	movlw	SPBRG_CONST
	movwf	SPBRG
	movlw	TXSTA_CONST
	movwf	TXSTA
	banksel	RCSTA		;  0.
	movlw	RCSTA_CONST
	movwf	RCSTA
	movlw	data_gps	;    (    
 	movwf	FSR_prer	; GPS)   FSR_prer,  
;   
	banksel	PIE1		;  1.	
	bsf	PIE1,RCIE	;     USART
	banksel	INTCON		;  0.
	bsf	INTCON,PEIE	;    
	bsf	INTCON,GIE	;     
;----------------------------------------------
	bsf	SETTINGS2,1	;    /  GPS
;----------------------------------------------
;  

;==============================================
;	  
;==============================================
main
;__________________________________________________________________
;   
;__________________________________________________________________
;       -   
	pagesel	TIMER_SET
	call	TIMER_SET		;  
	pagesel	main_tmr
	btfss	TIMER_RH,TIMER_RH_CONST	; ,     
	goto	main_tmr		; ,  
	clrf	TIMER_RH		;  
	clrf	TIMER_RL
;  RTC
	pagesel	main_nortc
	btfsc	CorrS,0			; ,       
	goto	main_nortc		; ,  
	pagesel	main_nortc
	btfsc	SETTINGS,1
	goto	main_nortc		; ,    
	pagesel	main_nortc
	btfsc	CorrS,7		
	goto	main_nortc		;  ,    		;
	pagesel	RTC_READ
	call	RTC_READ		;  
;    /  GPS
	pagesel	FZDT
	call	FZDT
;  /
	pagesel	DOUT_DT
	call	DOUT_DT			;  /
main_nortc
;  
	pagesel	BUTTON_CHECK
	call	BUTTON_CHECK
;   
	pagesel	MENU
	call	MENU
;   
	pagesel	main_noflash
	btfss	CorrS,1			;    
	goto	main_noflash		; CorrS,1 = 0,   
	pagesel	FLASH_WRITE
	call	FLASH_WRITE		;     
	bcf	CorrS,1			;    
main_noflash
;  
	pagesel	main_nou
	btfss	IZM_UP,2		;      
	goto	main_nou		; IZM_UP,2 = 0,   
	pagesel	DOUT_U
	call	DOUT_U			;  
	pagesel	DVS_WORK
	call	DVS_WORK		;    
	bcf	IZM_UP,2		;      
main_nou
;   
	pagesel	main_noo
	btfss	IZM_UP,3		;       
	goto	main_noo		; IZM_UP,3 = 0,   
	pagesel	DOUT_B
	call	DOUT_B			;   
	bcf	IZM_UP,3		;      
main_noo
;   GPS
	btfsc	BUTTONS,3		;    
	bsf	GPS_POWER
	btfss	BUTTONS,3		;    
	bcf	GPS_POWER
;    
	pagesel	DOUT_O
	call	DOUT_O			;   
;   
	pagesel	main_nospeed
	btfss	BUTTONS,3		;      
	goto	main_nospeed		; BUTTONS,3 = 0,   
	pagesel	SPEED_CALC		;      
	call	SPEED_CALC		;   
	pagesel	DOUT_SPEED
	call	DOUT_SPEED		;   
main_nospeed	
;    ,   RTL
	pagesel	DT_CALC
	call	DT_CALC
;_____________________________________________________________________________
main_tmr
	clrwdt				;   .
	pagesel	UP_IZMER		;     
	call	UP_IZMER
;    GPS
	pagesel	main_nogps
	btfss	CALC_I,0		;      GPS 
	goto	main_nogps		; CALC_I,0=0,    
	pagesel	GPS_ALL
	call	GPS_ALL			;   
main_nogps


;____________________________________________________________________
;      
	pagesel	main
	goto	main
;==============================================
;	 
;==============================================
	#include	<Pauses16Mhz_ms.INC>	;     
	#include	<TM1637_3_ms.INC>	;      TM1637
	#include	<RTC_ms.INC>		;      DS3231
	#include	<I2C_soft_16mhz_ms.INC>	;      I2C
	#include	<Timer_ms.INC>		;       
	#include	<Flash_ST24C16_ms.INC>	;       
	#include	<Time_Date_ms.INC>	;         
	#include	<Ariphmetic_ms.INC>	;     
	#include	<Display_ms.INC>	;     
	#include	<Buttons_ms.INC>	;    
	#include	<Menu_ms.INC>		;    
	#include	<Analog_ms.INC>		;     
	#include	<GPS_ms.INC>		;    GPS 
	#include	<Speed_ms.INC>		;    
;==============================================
;	
;==============================================
;
;==============================================
	END